require("scrollbar");

function love.load()
	list = {};

	content = {};
	content.x = 10;
	content.y = 10;

	content.w = 200;
	content.h = 202;

	itemH = 20;

	for i = 0, 50 do
		local temp = {}

		temp.w = 100;
		temp.h = itemH;
		temp.x = content.x + 0;
		temp.y = content.y + (i * itemH);
		temp.text = "items #" .. i;

		table.insert(list, temp);
	end

	scroll = scrollbar();
	scroll.x = (content.x + content.w);
	scroll.y = content.y;
	scroll.w = 20;
	scroll.h = content.h;
	scroll.contentHeight = (#list * itemH);

	scroll:loadScroll();
end

function love.update(dt)
	scroll:updateScroll(dt);
end

function love.mousepressed(x, y, button)
	scroll:mousepressedScroll(x, y, button);
end

function love.mousereleased(x, y, button)
	scroll:mousereleasedScroll(x, y, button);
end

function love.draw()
	local min = maxItem((content.y + 10) + (scroll.scrollY + 2));
	local max = maxItem(content.h + (scroll.scrollY + 2));
	
	if min == 0 then
    	min = 1;
    end
    if max >= #list or max == 0 then
    	max = #list;
    end

	love.graphics.print("All items: " .. #list, 350, 10);
	love.graphics.print("view items: " .. max, 350, 30);
	--love.graphics.print("scroll.contentHeight: " .. scroll.contentHeight, 350, 50);
	love.graphics.print("content.h: " .. content.h, 350, 50);

	for i = min, max do -- for i, v in ipairs(list) do
		local v = list[i];

		love.graphics.rectangle("line", v.x, v.y - scroll.scrollY, v.w, v.h);
		love.graphics.print(v.text, v.x, (v.y + 5) - scroll.scrollY);
	end

	love.graphics.rectangle("line", content.x, content.y, content.w, content.h);

	scroll:drawScroll();
end

-- position del scroll menos la posicion actual.
function maxItem(y)
	if y < content.y then
		return 0;
	end

	return math.floor(y / itemH);
end